function y=trisize(t,x,y,z)
	a=t(1);
	b=t(2);
	c=t(3);
	lab=(x(a)-x(b))^2+(y(a)-y(b))^2+(z(a)-z(b))^2;
	lac=(x(a)-x(c))^2+(y(a)-y(c))^2+(z(a)-z(c))^2;
	lbc=(x(c)-x(b))^2+(y(c)-y(b))^2+(z(c)-z(b))^2;
	y=sqrt(max([lab,lac,lbc]));
end

function [A,B,C]=getlongestside(t,x,y,z)
	a=t(1);
	b=t(2);
	c=t(3);
	lab=(x(a)-x(b))^2+(y(a)-y(b))^2+(z(a)-z(b))^2;
	lac=(x(a)-x(c))^2+(y(a)-y(c))^2+(z(a)-z(c))^2;
	lbc=(x(c)-x(b))^2+(y(c)-y(b))^2+(z(c)-z(b))^2;
	if(lab>=lac & lab>=lbc)
		A=a;
		B=b;
		C=c;
	else if(lac>=lab & lac>=lbc)
		A=a;
		B=c;
		C=b;
	else
		A=c;
		B=b;
		C=a;
	end
	end
end

function [mid,s] = getmid2(g,t,xp,yp,zp)
	% get longest side
	[a,b,c] = getlongestside(t,xp,yp,zp);
	x = (xp(a)+xp(b))/2;
	y = (yp(a)+yp(b))/2;
	z = g(x,y);
	mid = [x,y,z];
	s = [a,b,c];
end

function r = sorttri2(t,x,y,z)
	a=t(1);b=t(2);c=t(3);
	A=[x(a)-x(c),y(a)-y(c),z(a)-z(c)];
	B=[x(b)-x(c),y(b)-y(c),z(b)-z(c)];
	C=[x(c),y(c),1];
	g=cross(A,B)*C';
	if(g<0)
		r=[b,a,c];
	else
		r=t;
	end
end

function r=sorttris2(I,x,y,z)
	for i=1:size(I)(1)
		I(i,1:3)=sorttri2(I(i,:),x,y,z);
	end
	r=0;
end
		

function [I,x,y,z]=subdivide2(g,I0,x0,y0,z0)
	x=x0;
	y=y0;
	z=z0;
	I=0;
	for i=1:size(I0)(1)
		t = I0(i,:); % previous triangle
		[mid,s] = getmid2(g,t,x,y,z);
		n = length(x);
		x(n+1) = mid(1);
		y(n+1) = mid(2);
		z(n+1) = mid(3);
		I(2*i-1,1:3) = [s(1), s(3), n+1];
		I(2*i,1:3)   = [s(2), s(3), n+1];
	end
end


function [I,x,y,z,n]=subdivide3(g,I0,x0,y0,z0,e)
	x=x0;
	y=y0;
	z=z0;
	I=0;
	k=1;
	n=0;
	for i=1:size(I0)(1)
		t = I0(i,:); % previous triangle
		if(trisize(t,x,y,z)<e)
			I(k++,1:3) = t;
		else
			[mid,s] = getmid2(g,t,x,y,z);
			n = length(x);
			x(n+1) = mid(1);
			y(n+1) = mid(2);
			z(n+1) = mid(3);
			I(k++,1:3) = [s(1), s(3), n+1];
			I(k++,1:3)   = [s(2), s(3), n+1];
			n++;
		end
	end
end


function [I,x,y,z]=triangulate(g,I0,x0,y0,z0,e)
%% usage:
%% 
%% Triangulate surface z=g(x,y), maximum triangle length is smaller than e.
%% x,y,z are coordiante values, I is a Nx3 matrix specifying indices of 
%% triangle points. I0,x0,y0,z0 is either an initial triangulation, or
%% I0=0, z0=0, x0=[xleft,xright], y0=[yfront,yrear].
%% $X{
%% >> function z=f(x,y) 
%% >   r=sqrt(x*x+y*y);
%% >   z=exp(-r)*cos(4*r); 
%% >  end
%% >> [I,x,y,z]=triangulate(@f,0,
%% >        [-4,4],[-4,4],0,0.4);
%% >> trisurf(I,x,y,z)
%% >> set("light",[-1,-0.3,-1])
%% }
%% $I{triangulate.png}
%% $L{trimesh,trisurf,trisphere,delaunay}
	I=I0; 
	x=x0;
	y=y0;
	z=z0;
	if(I==0 & length(x)==2 & length(y)==2 & z==0)
		I=[2,1,3;2,3,4];
		x=[x0(1),x0(1),x0(2),x0(2)];
		y=[y0(1),y0(2),y0(1),y0(2)];
		for i=1:4
			z(i)=g(x(i),y(i));
		end
	end
			
	n=1;
	iter=1;
	maxiter=15;
	while n>0
%		printf("%f\n",n);
		[I,x,y,z,n] = subdivide3(g,I,x,y,z,e);
		if iter++>maxiter
			break;
		end
	end
	sorttris2(I,x,y,z);
end